"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var constants_1 = require("./constants");
var redux_1 = require("redux");
var reducer_1 = require("./reducer");
var ReduxNormalizedCache = (function () {
    function ReduxNormalizedCache(data, reduxCacheConfig) {
        if (data === void 0) { data = {}; }
        if (reduxCacheConfig === void 0) { reduxCacheConfig = {}; }
        this.reduxRootSelector = reduxCacheConfig.reduxRootSelector || 'apollo';
        this.store = reduxCacheConfig.store || redux_1.createStore(redux_1.combineReducers((_a = {}, _a[this.reduxRootSelector] = reducer_1.apolloReducer, _a)));
        this.store.dispatch({
            type: constants_1.APOLLO_OVERWRITE,
            data: data
        });
        var _a;
    }
    ReduxNormalizedCache.prototype.toObject = function () {
        return this.getReducer();
    };
    ReduxNormalizedCache.prototype.get = function (dataId) {
        return this.getReducer()[dataId];
    };
    ReduxNormalizedCache.prototype.set = function (dataId, value) {
        this.store.dispatch({
            type: constants_1.APOLLO_WRITE,
            data: (_a = {}, _a[dataId] = value, _a)
        });
        var _a;
    };
    ReduxNormalizedCache.prototype.merge = function (data) {
        this.store.dispatch({
            type: constants_1.APOLLO_WRITE,
            data: data
        });
    };
    ReduxNormalizedCache.prototype.delete = function (dataId) {
        this.store.dispatch({
            type: constants_1.APOLLO_WRITE,
            data: (_a = {}, _a[dataId] = undefined, _a)
        });
        var _a;
    };
    ReduxNormalizedCache.prototype.clear = function () {
        this.store.dispatch({
            type: constants_1.APOLLO_RESET,
        });
    };
    ReduxNormalizedCache.prototype.replace = function (newData) {
        var data = newData || {};
        this.store.dispatch({
            type: constants_1.APOLLO_OVERWRITE,
            data: data
        });
    };
    ReduxNormalizedCache.prototype.getReducer = function () {
        return this.store.getState()[this.reduxRootSelector];
    };
    return ReduxNormalizedCache;
}());
exports.ReduxNormalizedCache = ReduxNormalizedCache;
function reduxNormalizedCacheFactory(seed, reduxCacheConfig) {
    return new ReduxNormalizedCache(seed, reduxCacheConfig);
}
exports.reduxNormalizedCacheFactory = reduxNormalizedCacheFactory;
//# sourceMappingURL=reduxNormalizedCache.js.map